# API documentation for libmpg123, libout123, and libsyn123

Note: This API doc is automatically generated from the current development version that you can get via Subversion or as a daily snapshot from http://mpg123.org/snapshot. There may be differences (additions) compared to the latest stable release. See NEWS.libmpg123, NEWS.libout123, NEWS.libsyn123, and the overall NEWS file on libmpg123 versions and important changes between them.
Let me emphasize that the policy for the lib*123 family is to always stay backwards compatible -- only additions are planned (and it's not yet planned to change the plans;-).
Enumerations | Functions
mpg123 output audio format

Functions to get and select the format of the decoded audio. More...

## Enumerations
enum | mpg123_channelcount { MPG123_MONO = 1, MPG123_STEREO = 2 }

## Functions
MPG123_EXPORT void | mpg123_rates (const long **list, size_t *number)
MPG123_EXPORT void | mpg123_encodings (const int **list, size_t *number)
MPG123_EXPORT int | mpg123_encsize (int encoding)
MPG123_EXPORT int | mpg123_format_none (mpg123_handle *mh)
MPG123_EXPORT int | mpg123_format_all (mpg123_handle *mh)
MPG123_EXPORT int | mpg123_format (mpg123_handle *mh, long rate, int channels, int encodings)
MPG123_EXPORT int | mpg123_format2 (mpg123_handle *mh, long rate, int channels, int encodings)
MPG123_EXPORT int | mpg123_format_support (mpg123_handle *mh, long rate, int encoding)
MPG123_EXPORT int | mpg123_getformat (mpg123_handle *mh, long *rate, int *channels, int *encoding)
MPG123_EXPORT int | mpg123_getformat2 (mpg123_handle *mh, long *rate, int *channels, int *encoding, int clear_flag)

## Detailed Description

Functions to get and select the format of the decoded audio.

Before you dive in, please be warned that you might get confused by this. This seems to happen a lot, therefore I am trying to explain in advance. If you do feel confused and just want to decode your normal MPEG audio files that don't alter properties in the middle, just use mpg123_open_fixed() with a fixed encoding and channel count and forget about a matrix of audio formats. If you want to get funky, read ahead ...

The mpg123 library decides what output format to use when encountering the first frame in a stream, or actually any frame that is still valid but differs from the frames before in the prompted output format. At such a deciding point, an internal table of allowed encodings, sampling rates and channel setups is consulted. According to this table, an output format is chosen and the decoding engine set up accordingly (including optimized routines for different output formats). This might seem unusual but it just follows from the non-existence of "MPEG audio files" with defined overall properties. There are streams, streams are concatenations of (semi) independent frames. We store streams on disk and call them "MPEG audio files", but that does not change their nature as the decoder is concerned (the LAME/Xing header for gapless decoding makes things interesting again).

To get to the point: What you do with mpg123_format() and friends is to fill the internal table of allowed formats before it is used. That includes removing support for some formats or adding your forced sample rate (see MPG123_FORCE_RATE) that will be used with the crude internal resampler. Also keep in mind that the sample encoding is just a question of choice – the MPEG frames do only indicate their native sampling rate and channel count. If you want to decode to integer or float samples, 8 or 16 bit ... that is your decision. In a "clean" world, libmpg123 would always decode to 32 bit float and let you handle any sample conversion. But there are optimized routines that work faster by directly decoding to the desired encoding / accuracy. We prefer efficiency over conceptual tidyness.

People often start out thinking that mpg123_format() should change the actual decoding format on the fly. That is wrong. It only has effect on the next natural change of output format, when libmpg123 will consult its format table again. To make life easier, you might want to call mpg123_format_none() before any thing else and then just allow one desired encoding and a limited set of sample rates / channel choices that you actually intend to deal with. You can force libmpg123 to decode everything to 44100 KHz, stereo, 16 bit integer ... it will duplicate mono channels and even do resampling if needed (unless that feature is disabled in the build, same with some encodings). But I have to stress that the resampling of libmpg123 is very crude and doesn't even contain any kind of "proper" interpolation.

In any case, watch out for MPG123_NEW_FORMAT as return message from decoding routines and call mpg123_getformat() to get the currently active output format.

## Enumeration Type Documentation

## ◆ mpg123_channelcount

enum mpg123_channelcount

They can be combined into one number (3) to indicate mono and stereo...

Enumerator
MPG123_MONO | mono
MPG123_STEREO | stereo

Definition at line 670 of file mpg123.h.

## Function Documentation

## ◆ mpg123_rates()

MPG123_EXPORT void mpg123_rates | ( | const long ** | list,
|  | size_t * | number
| ) |  |

An array of supported standard sample rates These are possible native sample rates of MPEG audio files. You can still force mpg123 to resample to a different one, but by default you will only get audio in one of these samplings. This list is in ascending order.

Parameters

  list | Store a pointer to the sample rates array there.
  number | Store the number of sample rates there.

## ◆ mpg123_encodings()

MPG123_EXPORT void mpg123_encodings | ( | const int ** | list,
|  | size_t * | number
| ) |  |

An array of supported audio encodings. An audio encoding is one of the fully qualified members of mpg123_enc_enum (MPG123_ENC_SIGNED_16, not MPG123_SIGNED).

Parameters

  list | Store a pointer to the encodings array there.
  number | Store the number of encodings there.

## ◆ mpg123_encsize()

MPG123_EXPORT int mpg123_encsize | ( | int | encoding | ) |

Return the size (in bytes) of one mono sample of the named encoding.

Parameters

  encoding | The encoding value to analyze.

Returns
  positive size of encoding in bytes, 0 on invalid encoding.

## ◆ mpg123_format_none()

MPG123_EXPORT int mpg123_format_none | ( | mpg123_handle * | mh | ) |

Configure a mpg123 handle to accept no output format at all, use before specifying supported formats with mpg123_format

Parameters

  mh | handle

Returns
  MPG123_OK on success

## ◆ mpg123_format_all()

MPG123_EXPORT int mpg123_format_all | ( | mpg123_handle * | mh | ) |

Configure mpg123 handle to accept all formats (also any custom rate you may set) – this is default.

Parameters

  mh | handle

Returns
  MPG123_OK on success

## ◆ mpg123_format()

MPG123_EXPORT int mpg123_format | ( | mpg123_handle * | mh,
|  | long | rate,
|  | int | channels,
|  | int | encodings
| ) |  |

Set the audio format support of a mpg123_handle in detail:

Parameters

  mh | handle
  rate | The sample rate value (in Hertz).
  channels | A combination of MPG123_STEREO and MPG123_MONO.
  encodings | A combination of accepted encodings for rate and channels, p.ex MPG123_ENC_SIGNED16 | MPG123_ENC_ULAW_8 (or 0 for no support). Please note that some encodings may not be supported in the library build and thus will be ignored here.

Returns
  MPG123_OK on success, MPG123_ERR if there was an error.

## ◆ mpg123_format2()

MPG123_EXPORT int mpg123_format2 | ( | mpg123_handle * | mh,
|  | long | rate,
|  | int | channels,
|  | int | encodings
| ) |  |

Set the audio format support of a mpg123_handle in detail:

Parameters

  mh | handle
  rate | The sample rate value (in Hertz). Special value 0 means all rates (the reason for this variant of mpg123_format()).
  channels | A combination of MPG123_STEREO and MPG123_MONO.
  encodings | A combination of accepted encodings for rate and channels, p.ex MPG123_ENC_SIGNED16 | MPG123_ENC_ULAW_8 (or 0 for no support). Please note that some encodings may not be supported in the library build and thus will be ignored here.

Returns
  MPG123_OK on success, MPG123_ERR if there was an error.

## ◆ mpg123_format_support()

MPG123_EXPORT int mpg123_format_support | ( | mpg123_handle * | mh,
|  | long | rate,
|  | int | encoding
| ) |  |

Check to see if a specific format at a specific rate is supported by mpg123_handle.

Parameters

  mh | handle
  rate | sampling rate
  encoding | encoding

Returns
  0 for no support (that includes invalid parameters), MPG123_STEREO, MPG123_MONO or MPG123_STEREO|MPG123_MONO.

## ◆ mpg123_getformat()

MPG123_EXPORT int mpg123_getformat | ( | mpg123_handle * | mh,
|  | long * | rate,
|  | int * | channels,
|  | int * | encoding
| ) |  |

Get the current output format written to the addresses given. If the stream is freshly loaded, this will try to parse enough of it to give you the format to come. This clears the flag that would otherwise make the first decoding call return MPG123_NEW_FORMAT.

Parameters

  mh | handle
  rate | sampling rate return address
  channels | channel count return address
  encoding | encoding return address

Returns
  MPG123_OK on success

## ◆ mpg123_getformat2()

MPG123_EXPORT int mpg123_getformat2 | ( | mpg123_handle * | mh,
|  | long * | rate,
|  | int * | channels,
|  | int * | encoding,
|  | int | clear_flag
| ) |  |

Get the current output format written to the addresses given. This differs from plain mpg123_getformat() in that you can choose not to clear the flag that would trigger the next decoding call to return MPG123_NEW_FORMAT in case of a new format arriving.

Parameters

  mh | handle
  rate | sampling rate return address
  channels | channel count return address
  encoding | encoding return address
  clear_flag | if true, clear internal format flag

Returns
  MPG123_OK on success